﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using HeuristicLab.Core;

namespace HeuristicLab.Hive.Slave.Console {
  internal class LogServiceReader : ILogReader {

    private SlaveConsoleService.SlaveConsoleCommunicatorClient slaveCommunicator;
    private Timer timer;
    private int messageCount = 0;

    public LogServiceReader(SlaveConsoleService.SlaveConsoleCommunicatorClient slaveCommunicator) {
      this.slaveCommunicator = slaveCommunicator;
    }

    public void Start() {
      timer = new Timer();
      timer.Interval = 2000;
      timer.Tick += new EventHandler(timer_Tick);
      timer.Start();
    }

    void timer_Tick(object sender, EventArgs e) {
      try {
        var messages = slaveCommunicator.GetLogMessages();
        var newMessages = messages.GetRange(messageCount, messages.Count - messageCount);
        messageCount = messages.Count;
        OnMoreData(newMessages);
      }
      catch { }
    }

    public void Stop() {
      timer.Stop();
    }

    public event MoreDataHandler MoreData;
    private void OnMoreData(IEnumerable<string> newMessages) {
      var handler = MoreData;
      var newData = string.Join(Environment.NewLine, newMessages.ToArray());
      if(newMessages.Count() > 0) newData += Environment.NewLine;
      if (handler != null) MoreData(this, newData);
    }
  }
}
